package net.sf.tomp.xml.include;

import net.sf.tomp.xml.type.Type;
import net.sf.tomp.xml.type.VariantImpl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class AdaptiveXIncludeFilter extends AdaptiveFilterImpl {
    private Log log = LogFactory.getLog(AdaptiveXIncludeFilter.class);

    /** DOCUMENT ME! */
    protected XIncludeFilter xif;

    private final String XINCLUDE_NAMESPACE = "http://tomp.sf.net/ns/axi/1.0";

    /**
     * Creates a new AdaptiveXIncludeFilter object.
     */
    public AdaptiveXIncludeFilter() {
        super();
        xif = getXIncludeFilter();
        xif.setParent(parent);
        parent = xif;
        log.debug("\n&&&& " + this + "<init>: xif=" + xif);
    }

    /**
     * Construct an XML filter with the specified parent.
     * 
     * @param p DOCUMENT ME!
     * @see #setParent
     * @see #getParent
     */
    public AdaptiveXIncludeFilter(XMLReader p) {
        super(p);
        xif = getXIncludeFilter();
        xif.setParent(parent);
        parent = xif;
        log.debug("\n&&&& " + this + "<init>: xif=" + xif);

        //System.out.println("\n&&&& AdaptiveXIncludeFilter<init>:
        // parent="+getParent());
    }

    /**
     * DOCUMENT ME!
     * 
     * @param p DOCUMENT ME!
     */
    public void setParent(XMLReader p) {
        xif.setParent(typeDetectorFilter);
        this.parent = xif;

        //System.out.println(" $$$ "+this+" setParent to
        // "+typeDetectorFilter+"... ");
        if (typeDetectorFilter != null) {
            typeDetectorFilter.setParent(p);
        }
    }

    /*
     * public void setDocumentLocator(Locator locator) { if(locator == null ||
     * locator.getSystemId() == null) { //System.out.println("########
     * "+this+".(trying to)setDocumentLocator=null"); return; }
     * //super.setDocumentLocator(locator); xif.setDocumentLocator(locator); }
     */
    public XIncludeFilter getXIncludeFilter() {
        final AdaptiveXIncludeFilter axi = this;

        XIncludeFilter xif = new XIncludeFilter() {
            public String getXIncludeNamespace() {
                return XINCLUDE_NAMESPACE;
            }

            public XMLReader getXMLReader(String variant) throws SAXException {
                //System.out.println("GETTING getXMLReader with
                // locator="+axi.locator);
                XMLReader parser = super.getXMLReader(variant);

                // adaptive filter reading from standard parser
                AdaptiveFilterImpl adaptive = new AdaptiveXIncludeFilter(parser); //new

                // AdaptiveFilterImpl(parser);
                log.debug("+++++ returning " + adaptive
                        + " from getXMLReader() in " + this);

                // adaptive type database
                adaptive.setVariant(new VariantImpl(variant));
                adaptive.setTypeDatabase(getTypeDatabase());

                Type s = getSourceType();
                Type t = getSourceTypeForCurrentContext();

                //System.out.println("--- sourcetype "+s+" st for context "+t);
                adaptive.setTargetType(t);

                //adaptive.setDocumentLocator(axi.locator);
                return adaptive;
            }
        };

        log.debug("--- returning " + xif + " from getXIncludeFilter() in "
                + this);

        return xif;
    }

    /**
     * @return Returns the xINCLUDE_NAMESPACE.
     */
    public String getXIncludeNamespace() {
        return XINCLUDE_NAMESPACE;
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
