package net.sf.tomp.xml.type;

import net.sf.tomp.xtcl.filter.*;

import org.xml.sax.*;

import java.util.*;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class MultiFilterTypeTransformation implements MultiTransformation {
    // FIXME: should we consider only-identities-multitransf as a special case?

    /** DOCUMENT ME! */
    protected double costs = 1;

    /** DOCUMENT ME! */
    protected List transformations = new ArrayList();

    /** DOCUMENT ME! */
    protected Map params = new HashMap();

    /**
     * Creates a new MultiFilterTypeTransformation object.
     */
    public MultiFilterTypeTransformation() {
    }

    /**
     * Creates a new MultiFilterTypeTransformation object.
     * 
     * @param ts DOCUMENT ME!
     */
    public MultiFilterTypeTransformation(List ts) {
        int size = ts.size();

        for (int i = 0; i < size; i++) {
            TypeTransformation tt = (TypeTransformation) ts.get(i);

            if (tt.isIdentity()) {
                continue;
            }

            costs += tt.getCosts();
            transformations.add(tt);
        }
    }

    /**
     * DOCUMENT ME!
     * 
     * @param k DOCUMENT ME!
     * @param v DOCUMENT ME!
     */
    public void setParameter(String k, Object v) {
        if (transformations.size() > 0) {
            TypeTransformation tt = (TypeTransformation) transformations.get(0);

            tt.setParameter(k, v);
        }

        //System.out.println("Setting param "+k+"="+v);
    }

    /**
     * DOCUMENT ME!
     * 
     * @param tt DOCUMENT ME!
     */
    public void addTransformation(TypeTransformation tt) {
        if ((tt == null) || tt.isIdentity()) {
            return;
        }

        costs += tt.getCosts();
        transformations.add(tt);
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     * @throws TypeTransformationException DOCUMENT ME!
     */
    public XMLFilter newFilter() throws TypeTransformationException {
        // FIXME: does not set parameters to newly created filter
        DynamicMultiFilterImpl dmf = new DynamicMultiFilterImpl();

        //System.out.println(" @"+Integer.toHexString(hashCode())+"
        // newFilter()=>"+dmf);
        int size = transformations.size();

        for (int i = 0; i < size; i++) {
            TypeTransformation tt = (TypeTransformation) transformations.get(i);

            XMLFilter f = null;

            try {
                f = tt.newFilter();
                dmf.addFilter(i, f);
            } catch (SAXException se) {
                throw new TypeTransformationException("Cannot add filter " + f
                        + " to " + dmf, se);
            }
        }

        //System.out.println(" @"+Integer.toHexString(hashCode())+" newFilter()
        // CREATED");
        return dmf;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public double getCosts() {
        return costs;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String toString() {
        return "MultiFilterTypeTransformation@"
                + Integer.toHexString(hashCode()) + "(transformations="
                + transformations + ")";
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public boolean isIdentity() {
        return transformations.size() == 0;
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
