package net.sf.tomp.xml.type;

import net.sf.tomp.xtcl.filter.*;

import org.xml.sax.XMLFilter;

import javax.xml.transform.*;

import java.util.*;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class StyleTypeTransformation implements TypeTransformation {
    /** DOCUMENT ME! */
    public static final double STYLE_COSTS = 10;

    /** DOCUMENT ME! */
    protected String styleSystemId;

    /** DOCUMENT ME! */
    protected XTFilterFactory factory;

    /** DOCUMENT ME! */
    protected Map params = new HashMap();

    /**
     * Creates a new StyleTypeTransformation object.
     * 
     * @param ff DOCUMENT ME!
     * @param styleSystemId DOCUMENT ME!
     * @throws TransformerConfigurationException DOCUMENT ME!
     */
    public StyleTypeTransformation(XTFilterFactory ff, String styleSystemId)
            throws TransformerConfigurationException {
        factory = ff;
        this.styleSystemId = styleSystemId;
    }

    /**
     * DOCUMENT ME!
     * 
     * @param k DOCUMENT ME!
     * @param v DOCUMENT ME!
     */
    public void setParameter(String k, Object v) {
        params.put(k, v);
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     * @throws TypeTransformationException DOCUMENT ME!
     */
    public XMLFilter newFilter() throws TypeTransformationException {
        try {
            // create new TransformerFilterImpl
            XMLFilter f = factory.newTransformerFilter(styleSystemId);

            //System.out.println(" @"+Integer.toHexString(hashCode())+"
            // newFilter()=>"+f);
            // fill params
            for (Iterator i = params.entrySet().iterator(); i.hasNext();) {
                Map.Entry e = (Map.Entry) i.next();
                String k = (String) e.getKey();
                Object v = e.getValue();

                ((XTFilter) f).setParameter(k, v);
            }

            return f;
        } catch (TransformerConfigurationException tce) {
            throw new TypeTransformationException(tce);
        }
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public double getCosts() {
        return STYLE_COSTS;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String toString() {
        return "StyleTypeTransformation@" + Integer.toHexString(hashCode())
                + "(" + styleSystemId + ")";
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public boolean isIdentity() {
        return false;
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
