package net.sf.tomp.xml.type;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class TypeContextImpl implements TypeContext {
    /** DOCUMENT ME! */
    public static final TypeContextImpl ROOT = new TypeContextImpl("/");

    /** DOCUMENT ME! */
    protected final String context;

    /**
     * Creates a new TypeContextImpl object.
     * 
     * @param s DOCUMENT ME!
     * @throws IllegalArgumentException DOCUMENT ME!
     */
    public TypeContextImpl(String s) {
        if ((s == null) || (s.length() == 0)) {
            throw new IllegalArgumentException(
                    "TypeContextImpl cannot have null or empty String.");
        }

        int lastSlash = s.lastIndexOf('/');

        if ((lastSlash == (s.length() - 1)) && (lastSlash > 0)) {
            s = s.substring(0, lastSlash);
        }

        context = s;
    }

    /**
     * Creates a new TypeContextImpl object.
     * 
     * @param parent DOCUMENT ME!
     * @param s DOCUMENT ME!
     * @throws IllegalArgumentException DOCUMENT ME!
     */
    public TypeContextImpl(TypeContextImpl parent, String s) {
        //System.out.println("///// creating TypeContextImpl, parent="+parent+"
        // s="+s);
        if ((s == null) || (s.length() == 0)) {
            throw new IllegalArgumentException(
                    "TypeContextImpl cannot have null or empty String.");
        }

        int lastSlash = s.lastIndexOf('/');

        if ((lastSlash == (s.length() - 1)) && (lastSlash > 0)) {
            s = s.substring(0, lastSlash);
        }

        if (parent == null) {
            context = s;
        } else {
            String pc = parent.context;

            if (pc.length() == 1) {
                context = "/" + s;
            } else {
                context = parent.context + "/" + s;
            }
        }
    }

    /**
     * DOCUMENT ME!
     * 
     * @param c DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    public boolean matches(TypeContext c) {
        if (c instanceof TypeContextImpl) {
            TypeContextImpl ci = (TypeContextImpl) c;

            return ci.context.startsWith("/") ? equals(ci) : context
                    .endsWith(ci.context);
        } else {
            return false;
        }
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String toString() {
        return "TypeContextImpl[" + context + "]";
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public TypeContext getParent() {
        if (context.length() <= 1) {
            return null;
        }

        int lastSlash = context.lastIndexOf('/');

        if (lastSlash == 0) {
            return ROOT;
        }

        return new TypeContextImpl(context.substring(0, lastSlash));
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public int hashCode() {
        return context.hashCode();
    }

    /**
     * DOCUMENT ME!
     * 
     * @param o DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }

        TypeContextImpl c = (TypeContextImpl) o;

        return c.context.equals(context);
    }

    /*
     * public static void main(String[] args) { System.out.println(false == new
     * TypeContextImpl("/a/b/c").matches(new TypeContextImpl("/a/b")));
     * System.out.println(true == new TypeContextImpl("/a/b/c").matches(new
     * TypeContextImpl("/a/b/c"))); System.out.println(false == new
     * TypeContextImpl("a/b/c").matches(new TypeContextImpl("a/b/c/d")));
     * System.out.println(true == new TypeContextImpl("x/a/b/c").matches(new
     * TypeContextImpl("a/b/c"))); System.out.println(new
     * TypeContextImpl("x/a/b/c/")); System.out.println(new
     * TypeContextImpl("x/a/b/c").getParent()); System.out.println(new
     * TypeContextImpl("x/a/b/c").getParent().getParent());
     * System.out.println(new
     * TypeContextImpl("x/a/b/c").getParent().getParent().getParent()); }
     */
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
