package net.sf.tomp.xml.type;

import net.sf.tomp.xtcl.filter.XTFilterImpl;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class TypeDetectorFilter extends XTFilterImpl implements TypeDetector {
    /** DOCUMENT ME! */
    protected boolean wasDD;

    /** DOCUMENT ME! */
    protected String dtName;

    /** DOCUMENT ME! */
    protected String dtPublicId;

    /** DOCUMENT ME! */
    protected String dtSystemId;

    /** DOCUMENT ME! */
    protected int depth;

    /** DOCUMENT ME! */
    protected Type type;

    /** DOCUMENT ME! */
    protected TypeDatabase typeDatabase;

    /** DOCUMENT ME! */
    protected TypeContextImpl context;

    /**
     * Creates a new TypeDetectorFilter object.
     */
    public TypeDetectorFilter() {
        super();
    }

    /**
     * Construct an XML filter with the specified parent.
     * 
     * @param parent DOCUMENT ME!
     * @see #setParent
     * @see #getParent
     */
    public TypeDetectorFilter(XMLReader parent) {
        super(parent);
    }

    /**
     * DOCUMENT ME!
     * 
     * @param k DOCUMENT ME!
     * @param v DOCUMENT ME!
     */
    public void setParameter(String k, Object v) { /*
                                                    * if("tomp.xtcl.filter.XTFilterFactory".equalsIgnoreCase(k)) {
                                                    * typeDatabase.setXTFilterFactory((XTFilterFactory)v); }
                                                    * else
                                                    * if("tomp.xml.type.TypeDatabaseFilter".equalsIgnoreCase(k)) {
                                                    * typeDatabase =
                                                    * (TypeDatabaseFilter)v; }
                                                    * else
                                                    */
        super.setParameter(k, v);
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public Type getType() {
        return type;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public TypeContext getTypeContext() {
        return context;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public Type getTypeForCurrentContext() {
        if (type == null) {
            return null;
        }

        TypeContext tc = getTypeContext();

        if (tc == null) {
            return type;
        }

        Type t = type.getTypeForContext(tc);

        return (t == null) ? type : t;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public TypeDatabase getTypeDatabase() {
        return typeDatabase;
    }

    /**
     * DOCUMENT ME!
     * 
     * @param td DOCUMENT ME!
     */
    public void setTypeDatabase(TypeDatabase td) {
        typeDatabase = td;
    }

    /*
     * public Result getResult() { return typeDatabase.getResult(); }
     */

    /**
     * Filter a start document event.
     * 
     * @exception SAXException The client may throw an exception during
     *                processing.
     */
    public void startDocument() throws SAXException {
        //System.out.println(""+this+".startDocument");
        wasDD = false;
        type = null;
        depth = 0;
        context = TypeContextImpl.ROOT;

        //System.out.println("*** start to detect type...");
    }

    /**
     * DOCUMENT ME!
     * 
     * @param ch DOCUMENT ME!
     * @param start DOCUMENT ME!
     * @param length DOCUMENT ME!
     * @throws SAXException DOCUMENT ME!
     */
    public void comment(char[] ch, int start, int length) throws SAXException {
        // hack: if type is not detected yet, do not send comments
        // (no handler known as well as...)
        // throws away comments before root element!!!
        if (type != null) {
            super.comment(ch, start, length);
        }
    }

    /**
     * Filter an end document event.
     * 
     * @param uri DOCUMENT ME!
     * @param localName DOCUMENT ME!
     * @param qName DOCUMENT ME!
     * @param atts DOCUMENT ME!
     * @exception SAXException The client may throw an exception during
     *                processing.
     */

    /*
     * public void endDocument () throws SAXException {
     * //System.out.println(""+this+".endDocument"); // Type sourceType =
     * typeDatabase.getTypeForPublicDoctype( // "-//OASIS//DTD DocBook XML
     * V4.1.2//EN"); // System.out.println("*** transformation
     * from="+sourceType+" to "+type+" is " //
     * +typeDatabase.getTransformation(sourceType, type)); super.endDocument(); }
     */

    /**
     * Filter a start element event.
     * 
     * @param uri The element's Namespace URI, or the empty string.
     * @param localName The element's local name, or the empty string.
     * @param qName The element's qualified (prefixed) name, or the empty
     *            string.
     * @param atts The element's attributes.
     * @exception SAXException The client may throw an exception during
     *                processing.
     */
    public void startElement(String uri, String localName, String qName,
            Attributes atts) throws SAXException {
        if ((type == null) && (depth == 0)) {
            type = typeDatabase.getTypeForRootElement(uri, localName);

            if (type == null) {
                type = TypeImpl.UNKNOWN;
            }

            contentHandler.setDocumentLocator(locator);
            super.startDocument();

            if (wasDD) {
                super.startDTD(dtName, dtPublicId, dtSystemId);
            }
        }

        depth++;
        context = new TypeContextImpl(context, qName);
        super.startElement(uri, localName, qName, atts);
    }

    /**
     * Filter an end element event.
     * 
     * @param uri The element's Namespace URI, or the empty string.
     * @param localName The element's local name, or the empty string.
     * @param qName The element's qualified (prefixed) name, or the empty
     *            string.
     * @exception SAXException The client may throw an exception during
     *                processing.
     */
    public void endElement(String uri, String localName, String qName)
            throws SAXException {
        super.endElement(uri, localName, qName);
        depth--; // switched 3/2/04 !!!
        context = (TypeContextImpl) context.getParent();
    }

    /**
     * Register the start of the DTD. Comments in the DTD are skipped because
     * they are not part of the XPath data model
     * 
     * @param name DOCUMENT ME!
     * @param publicId DOCUMENT ME!
     * @param systemId DOCUMENT ME!
     * @throws SAXException DOCUMENT ME!
     */
    public void startDTD(String name, String publicId, String systemId)
            throws SAXException {
        if (type == null) {
            type = typeDatabase.getTypeForDoctype(name, publicId, systemId);
        }

        wasDD = true;
        dtName = name;
        dtPublicId = publicId;
        dtSystemId = systemId;
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
